ON_Annotation Class Referenceabstract

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_annotation.h>`

Inheritance diagram for ON_Annotation:

## Public Member Functions

virtual ON_BOOL32 | IsRealObject () const =0
| ON_Annotation ()
| ON_Annotation (const ON_Annotation &)
| ~ON_Annotation ()
ON_Annotation & | operator= (const ON_Annotation &)
void | Create ()
void | Destroy ()
void | EmergencyDestroy ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
bool | IsText () const
bool | IsLeader () const
bool | IsDimension () const
virtual double | NumericValue () const
virtual void | SetTextToDefault ()
void | SetType (ON::eAnnotationType type)
ON::eAnnotationType | Type () const
void | SetTextDisplayMode (ON::eTextDisplayMode mode)
ON::eTextDisplayMode | TextDisplayMode () const
void | SetPlane (const ON_Plane &plane)
ON_Plane | Plane () const
int | PointCount () const
void | SetPoints (const ON_SimpleArray< ON_2dPoint > &points)
const ON_SimpleArray< ON_2dPoint > & | Points () const
void | SetPoint (int idx, ON_3dPoint point)
ON_2dPoint | Point (int idx) const
void | SetUserText (const wchar_t *string)
const ON_wString & | UserText () const
void | SetDefaultText (const wchar_t *string)
const ON_wString & | DefaultText () const
void | SetUserPositionedText (int bUserPositionedText)
bool | UserPositionedText () const
bool | GetECStoWCSXform (ON_Xform &xform) const
bool | GeWCStoECSXform (ON_Xform &xform) const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static const ON_3dmAnnotationSettings & | AnnotationSettings ()
static void | SetAnnotationSettings (const ON_3dmAnnotationSettings *)

## Public Attributes

ON::eAnnotationType | m_type
ON::eTextDisplayMode | m_textdisplaymode
ON_Plane | m_plane
ON_SimpleArray< ON_2dPoint > | m_points
ON_wString | m_usertext
ON_wString | m_defaulttext
bool | m_userpositionedtext

## Detailed Description

Definition at line 154 of file opennurbs_annotation.h.

## Constructor & Destructor Documentation

## ON_Annotation() [1/2]

ON_Annotation::ON_Annotation | ( |  | ) |

## ON_Annotation() [2/2]

ON_Annotation::ON_Annotation | ( | const ON_Annotation & |  | ) |

## ~ON_Annotation()

ON_Annotation::~ON_Annotation | ( |  | ) |

## Member Function Documentation

## AnnotationSettings()

static const ON_3dmAnnotationSettings& ON_Annotation::AnnotationSettings | ( |  | ) |

static

## Create()

void ON_Annotation::Create | ( |  | ) |

## DefaultText()

const ON_wString& ON_Annotation::DefaultText | ( |  | ) | const

## Destroy()

void ON_Annotation::Destroy | ( |  | ) |

## Dimension()

int ON_Annotation::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Dump()

void ON_Annotation::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## EmergencyDestroy()

void ON_Annotation::EmergencyDestroy | ( |  | ) |

## GetBBox()

ON_BOOL32 ON_Annotation::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetECStoWCSXform()

bool ON_Annotation::GetECStoWCSXform | ( | ON_Xform & | xform | ) | const

## GeWCStoECSXform()

bool ON_Annotation::GeWCStoECSXform | ( | ON_Xform & | xform | ) | const

## IsDimension()

bool ON_Annotation::IsDimension | ( |  | ) | const

## IsLeader()

bool ON_Annotation::IsLeader | ( |  | ) | const

## IsRealObject()

virtual ON_BOOL32 ON_Annotation::IsRealObject | ( |  | ) | const

pure virtual

Implemented in ON_Leader, ON_TextEntity, ON_AngularDimension, ON_RadialDimension, and ON_LinearDimension.

## IsText()

bool ON_Annotation::IsText | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_Annotation::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## NumericValue()

virtual double ON_Annotation::NumericValue | ( |  | ) | const

virtual

Referenced by ON_AngularDimension::Radius().

## ObjectType()

ON::object_type ON_Annotation::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## operator=()

ON_Annotation& ON_Annotation::operator= | ( | const ON_Annotation & |  | ) |

## Plane()

ON_Plane ON_Annotation::Plane | ( |  | ) | const

## Point()

ON_2dPoint ON_Annotation::Point | ( | int | idx | ) | const

## PointCount()

int ON_Annotation::PointCount | ( |  | ) | const

## Points()

const ON_SimpleArray<ON_2dPoint>& ON_Annotation::Points | ( |  | ) | const

## Read()

ON_BOOL32 ON_Annotation::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

Reimplemented in ON_TextEntity, and ON_AngularDimension.

## SetAnnotationSettings()

static void ON_Annotation::SetAnnotationSettings | ( | const ON_3dmAnnotationSettings * |  | ) |

static

## SetDefaultText()

void ON_Annotation::SetDefaultText | ( | const wchar_t * | string | ) |

## SetPlane()

void ON_Annotation::SetPlane | ( | const ON_Plane & | plane | ) |

## SetPoint()

void ON_Annotation::SetPoint | ( | int | idx,
|  | ON_3dPoint | point
| ) |  |

## SetPoints()

void ON_Annotation::SetPoints | ( | const ON_SimpleArray< ON_2dPoint > & | points | ) |

## SetTextDisplayMode()

void ON_Annotation::SetTextDisplayMode | ( | ON::eTextDisplayMode | mode | ) |

## SetTextToDefault()

virtual void ON_Annotation::SetTextToDefault | ( |  | ) |

virtual

Reimplemented in ON_AngularDimension, ON_RadialDimension, and ON_LinearDimension.

Referenced by ON_AngularDimension::Radius().

## SetType()

void ON_Annotation::SetType | ( | ON::eAnnotationType | type | ) |

## SetUserPositionedText()

void ON_Annotation::SetUserPositionedText | ( | int | bUserPositionedText | ) |

## SetUserText()

void ON_Annotation::SetUserText | ( | const wchar_t * | string | ) |

## TextDisplayMode()

ON::eTextDisplayMode ON_Annotation::TextDisplayMode | ( |  | ) | const

## Transform()

ON_BOOL32 ON_Annotation::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## Type()

ON::eAnnotationType ON_Annotation::Type | ( |  | ) | const

## UserPositionedText()

bool ON_Annotation::UserPositionedText | ( |  | ) | const

## UserText()

const ON_wString& ON_Annotation::UserText | ( |  | ) | const

## Write()

ON_BOOL32 ON_Annotation::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

Reimplemented in ON_TextEntity, and ON_AngularDimension.

## Member Data Documentation

## m_defaulttext

ON_wString ON_Annotation::m_defaulttext

Definition at line 286 of file opennurbs_annotation.h.

## m_plane

ON_Plane ON_Annotation::m_plane

Definition at line 282 of file opennurbs_annotation.h.

## m_points

ON_SimpleArray<ON_2dPoint> ON_Annotation::m_points

Definition at line 283 of file opennurbs_annotation.h.

## m_textdisplaymode

ON::eTextDisplayMode ON_Annotation::m_textdisplaymode

Definition at line 279 of file opennurbs_annotation.h.

## m_type

ON::eAnnotationType ON_Annotation::m_type

Definition at line 276 of file opennurbs_annotation.h.

## m_userpositionedtext

bool ON_Annotation::m_userpositionedtext

Definition at line 288 of file opennurbs_annotation.h.

## m_usertext

ON_wString ON_Annotation::m_usertext

Definition at line 285 of file opennurbs_annotation.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_annotation.h